use std::cell::RefCell;

fn main() {
    
    let vec = Vec::<i32>::new();

    // `RefCell<T>` allows runtime-checked mutable access to a `T`.
    let cell = RefCell::new(vec);

    // I can take a mutable borrow.
    let mut borrow1 = cell.borrow_mut();
    
    // But I cannot take two!
    let mut borrow2 = cell.borrow_mut();

    // If you don't write unsafe, you won't UB...
    // so instead you crash and burn.
    
    borrow1.push(1);
    borrow2.push(2);
}
