fn main() {
    // First create a `Vec`
    let mut vec = Vec::from([100, 101, 102]);

    // Let's take a raw pointer to the first item
    let ptr0 = &raw mut vec[0];

    // Also a raw pointer to the second item
    let ptr1 = unsafe { ptr0.add(1) };

    // Here I am implicitly taking a mutable reference to `vec`
    vec[0] = 300;

    // Unsafe but valid: no other reference at this point refers to
    // memory overlapping *ptr1.
    unsafe { *ptr1 = 301 };

    // Valid: there is no mutable reference to memory owned by `vec`.
    println!("OUTPUT: {:?}", &vec)
}